MODULE Project; (*$MAIN*)

IMPORT c := Console, Strings, Rsrc;

VAR
  n, len: INTEGER;
  byte, color: SHORTINT;
  msg1, msg2: Rsrc.Resource;

PROCEDURE NextColor;
BEGIN
  CASE color OF
  | c.RedOnBlack: color := c.YellowOnBlack;
  | c.YellowOnBlack: color := c.CyanOnBlack;
  | c.CyanOnBlack: color := c.MagentaOnBlack;
  | c.MagentaOnBlack: color := c.GreenOnBlack;
  | c.GreenOnBlack: color := c.RedOnBlack;
  ELSE END;
  c.SetColors(color);
END NextColor;

(* Work with a resource byte by byte: *)

PROCEDURE ShowMsg (msg: Rsrc.Resource);
VAR
  id: Rsrc.Ident;
BEGIN
  id := Rsrc.Open(msg);
  byte := Rsrc.ReadByte(id);
  WHILE byte # 0 DO
    NextColor; c.WriteCh(CHR(byte));
    byte := Rsrc.ReadByte(id);
  END;
  Rsrc.Close(msg);
END ShowMsg;

BEGIN
  c.Clear(c.Black); color := c.GreenOnBlack;
  len := Strings.Length(Rsrc.Str1);
  FOR n := 0 TO len-1 DO c.WriteCh(Rsrc.Str1[n]); NextColor END;
  c.WriteLn;
  len := Strings.Length(Rsrc.Str2);
  FOR n := 0 TO len-1 DO c.WriteCh(Rsrc.Str2[n]); NextColor END;
  c.WriteLn; c.WriteLn;
  ShowMsg(Rsrc.Msg1);
  c.WriteLn;
  ShowMsg(Rsrc.Msg2);
END Project.
